# ##### BEGIN GPL LICENSE BLOCK #####
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software Foundation,
#  Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
# ##### END GPL LICENSE BLOCK #####


import bpy
import os



category_list = []



def make_list(path):
	dir = ""
	open_file = "none"
	global global_object_list
	global global_object_values
	global_object_list = []
	disable_list = []
	global_object_values = []
	
	reset_dlist = disable_list

	absolute_path = os.path.realpath(bpy.path.abspath(path))
	for root, directo, files in os.walk(absolute_path):
		dir = directo
		break
	for folder in dir:


		new_directory = absolute_path + "/" + folder


		for file in os.listdir(new_directory):
			if file.endswith("objects.txt"):
				open_file = "objects.txt"


		if  open_file != "none":
			f = open(new_directory + "/" + open_file, 'r')
			open_file = "none"
			file_disabled = False
			end_values = False

			for line in f:
				line_disabled = False

				if line.find("disable = True") >= 0:
					file_disabled = True

				if line.find("disabled") >= 0:
					line_disabled = True

				if line.find("end values")>= 0:
					end_values = True

				if line.find("disable_")>= 0:
					disable_value = line.rstrip('\n').replace("disable_", "").replace(" = True","").replace("_"," ")
					if disable_value not in disable_list:
						disable_list.append(disable_value)

				if len(line) > 3 and file_disabled == False and end_values == True and line.find("end values") < 0 and line_disabled == False: 
					new_line = line.rstrip('\n').replace(", ", ",")
				
					list_objects = new_line.split(",")
					for disable_list_items in disable_list:
						if disable_list_items in list_objects:
							line_disabled = True
					if line_disabled == False:
						global_object_name = folder + "_" + list_objects[0]
						list_objects[0] = folder + "_" + list_objects[0]
						list_objects.append("FOLDER: " + folder)
						global_object_list.append((global_object_name,global_object_name,global_object_name))
						global_object_values.append(list_objects)
						for ob_value in list_objects:
							if "CATEGORY" in ob_value:
								category = ob_value.replace("CATEGORY: ", "")
								if (category, category, category) not in category_list:
									category_list.append((category, category, category))
				
					disable_list = reset_dlist
			f.close()





test_items = [("all", "all", "all")]
selected_image = "none"

def populate_coll(scene):
	bpy.app.handlers.scene_update_pre.remove(populate_coll)
	test_items.clear()
	test_items.append(("all", "all", "all"))
	scene.sel_category = "all"
	for cat_list_item in category_list:
		print (cat_list_item)
		test_items.append(cat_list_item)
	

	




def list_populate(self, context):
	global test_items
	return test_items










def dir_path_update(self, context):
	choose_path = context.scene.choose_path
	

	if choose_path:
		test_items.clear()
		test_items.append(("all", "all", "all"))
		context.scene.sel_category = "all"
		for cat_list_item in category_list:
			test_items.append(cat_list_item)
		

def category_choose(self, context):

	if context.scene.sel_category != "all":
		print ("not -all- selected")
		context.scene.game_object = ""
		sorted_objects = []
		for value in global_object_values:
			if ("CATEGORY: "+ context.scene.sel_category) in value:
				sorted_objects.append((value[0], value[0], value[0]))
		print (sorted_objects)
		context.scene.coll.clear()
		for identifier, name, description in sorted_objects:
			context.scene.coll.add().name = name

	else:
		print ("-all- selected")
		context.scene.game_object = ""
		print (context.scene.game_object)	
		context.scene.coll.clear()
	
		make_list(context.scene.choose_path)
		for identifier, name, description in global_object_list:
			context.scene.coll.add().name = name



def object_choose(self, context):
	global selected_image
	
	selected_image = get_object_value(context.scene.game_object, "IMAGE")
	if selected_image[0] == "no_value_found":
		selected_image = ["no_image_found.png"]
	print (selected_image)
	#??remove all other images??
	#??open selected image??
		



def get_object_value(ob, value):
	value_Found = False
	valueList = []
	for obs in global_object_values:
		if ob in obs:
			for values in obs:
				if values.find(value)>= 0:
					values = values.replace(value + ": ", "")
					valueList.append(values)
					value_Found = True
	if value_Found == False:
		valueList = ["no_value_found"]
	return valueList

	



			


